


#ifndef NULL
  #define  NULL    ((void *)0)
#endif


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
//    `Server' base class.                                             //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //


class Server {
protected :
  int threadId ;
  Server(int _threadId) : threadId(_threadId) {}
public :
  virtual ~Server() {} ;
  virtual void transition(MPI_Status*) = 0 ;
} ;


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
//    `Threads' class.                                                 //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class Threads {
  class ThreadStack {
  public :
    ThreadStack* parent ;
    int numThreads ;
    MPI_Request* events ;
    Server** servers ;

    ThreadStack(const int _numThreads, ThreadStack* _parent) ;
    ~ThreadStack() ;
  } ;

  ThreadStack* thrStk ;
public :
  Threads() ;
  ~Threads() ;

  MPI_Request* event(const int threadId) ;

  int allocateServerGroup(const int n) ;
  void deallocateServerGroup() ;

  void installServer(const int threadId, Server* server) ;

  void waitEvent(const int threadId) ;
  void waitServerTransition() ;
} ;


extern Threads* ths ;

